import refreshTokenHelper from "../../../../../utils/refreshTokenHelper"
import forceLogoutHelper from "../../../../../utils/forceLogoutHelper"
import errorHandlingHelper from "../../../../../utils/errorHandlingHelper"

const handleFunc = async (event: any, authToken: any = null) => {
  let data: any = {}
  const config = useRuntimeConfig()
  const token = authToken ?? await getTokenHelper(event)
  const body = await readBody(event)

  let newObjValue = {}
  if(body.locationId) {
    newObjValue = {...newObjValue, 
      C_Location_ID: {
        id: body.locationId,
        tableName: 'C_Location'
      }
    }
  }
  if(body.warehouseId) {
    newObjValue = {...newObjValue, 
      M_Warehouse_ID: {
        id: body.warehouseId,
        tableName: 'M_Warehouse'
      }
    }
  }
  if(body.orgTypeId) {
    newObjValue = {...newObjValue, 
      AD_OrgType_ID: {
        id: body.orgTypeId,
        tableName: 'AD_OrgType'
      }
    }
  }
  if(body.supervisorId) {
    newObjValue = {...newObjValue, 
      Supervisor_ID: {
        id: body.supervisorId,
        tableName: 'AD_User'
      }
    }
  }
  if(body.parentOrgId) {
    newObjValue = {...newObjValue, 
      Parent_Org_ID: {
        id: body.parentOrgId,
        tableName: 'AD_Org'
      }
    }
  }

  const res: any = await event.context.fetch('models/ad_orginfo', 'POST', token, {
    isActive: body.isActive ?? true,
    DUNS: body.DUNS || '?',
    taxID: body.taxID || '?',
    ...newObjValue,
    tableName: 'AD_OrgInfo'
  })
  if(res) {
    data = res
    data['status'] = 200
    data['message'] = ''
  }
  
  return data
}

export default defineEventHandler(async (event) => {
  let data: any = {}

  try {
    data = await handleFunc(event)
  } catch(err: any) {
    try {
      let authToken: any = await refreshTokenHelper(event)
      data = await handleFunc(event, authToken)
    } catch(error: any) {
      data = errorHandlingHelper(err?.data ?? err, error?.data ?? error)
      forceLogoutHelper(event, data)
    }
  }

  return data
})